;;=====================================================================
;  ϱ(2007.8.26 ָ)
;  ->Audit, Draworder, Purge,  Point<node> Delete,
;    Layer Filters Delete. Ghost delete.
;  ->ghost (2007.10.14)
;------- file filtering -----------------------------------------------
(defun c:ff(/ tg1 tg2 tg3 tg4 tg5 tg6 tg7 ky)
   (prompt "   ϱ...")
   (setq dcl_id (load_dialog "c:/ezqcad/ezqdcl/ff.dcl"))
   (setq ky 4 tg1 "0" tg2 "0" tg3 "0" tg4 "1" tg5 "1" tg6 "1" tg7 "0")
   (if (not (new_dialog "file_filter" dcl_id)) (exit))
   (set_tile "tog1" tg1)(set_tile "tog2" tg2)
   (set_tile "tog3" tg3)(set_tile "tog4" tg4)
   (set_tile "tog5" tg5)(set_tile "tog6" tg6)(set_tile "tog7" tg7)
   (action_tile "tog1" "(setq tg1 $value)")
   (action_tile "tog2" "(setq tg2 $value)")
   (action_tile "tog3" "(setq tg3 $value)")
   (action_tile "tog4" "(setq tg4 $value)")
   (action_tile "tog5" "(setq tg5 $value)")
   (action_tile "tog6" "(setq tg6 $value)")
   (action_tile "tog7" "(setq tg7 $value)(@ff_select tg7)")
   (action_tile "accept" "(setq ky 9)(done_dialog)")
   (action_tile "cancel" "(done_dialog)")
   (start_dialog)
(if (= ky 9)(progn
   (command "undo" "be")
   (if (= tg1 "1") (command "audit" "y"))
   (if (= tg2 "1") (@do))
   (if (= tg3 "1") (command "purge" "a" "*" "n"))
   (if (= tg4 "1") (@layerfilterdelete))
   (if (= tg5 "1") (@ghost))
   (if (= tg6 "1") (@pointdelete))
   (command "undo" "e")
   (prompt "\n>>Ϸ"))
   (prompt "\n>>")
)
(prin1))
;;subroutine
(defun @ff_select(tg7)
   (cond
      ((= tg7 "0")(setq tg1 "0" tg2 "0" tg3 "0" tg4 "0" tg5 "0" tg6 "0"))
      ((= tg7 "1")(setq tg1 "1" tg2 "1" tg3 "1" tg4 "1" tg5 "1" tg6 "1"))
   )
   (set_tile "tog1" tg1)(set_tile "tog2" tg2)
   (set_tile "tog3" tg3)(set_tile "tog4" tg4)
   (set_tile "tog5" tg5)(set_tile "tog6" tg6)(set_tile "tog7" tg7)
)
;;ָ ڷ (2007.07.28 ָ)
(defun @do(/ ss)
   (prompt " ָ ڷ ...")
   (setq ss (ssget "x" '((0 . "HATCH,TRACE"))) )
   (vl-cmdf "draworder" ss "" "b")
   (setq ss (ssget "x" '((0 . "TEXT,MTEXT,DIMENSION"))) )
   (vl-cmdf "draworder" ss "" "f")
   (prompt "\nָ ڷ ؽƮ  .")
(prin1))
;;̾  ϱ
(defun @layerfilterdelete(/ objXDict)
   (setq strKeepWC "")
   (vl-load-com)
   (vl-catch-all-apply
      (function
         (lambda ()
            (setq objXDict (vla-GetExtensionDictionary
                  (vla-get-Layers (vla-get-ActiveDocument (vlax-get-acad-object)))))))
   )
   (cond (objXDict
        (or
         (rrbI:DeleteAllXRecs objXDict "ACAD_LAYERFILTERS" strKeepWC)
         (rrbI:DeleteAllXRecs objXDict "AcLyDictionary" strKeepWC))))
(princ))
(defun rrbI:DeleteAllXRecs  (objXDict dictName strKeepWC / objDict i)
   (vl-catch-all-apply
   (function
      (lambda ()
         (setq objDict (vla-Item objXDict dictName))
         (vlax-for objXRec  objDict
            (cond ((not (and strKeepWC (wcmatch (vla-Get-Name objXRec) strKeepWC)))
               (setq i (1+ (cond (i)
                              (0))))
               (vla-Delete objXRec)))))))
   (cond (i (princ (strcat "\n" (itoa i) " filters deleted.")))))
 ;-->ghost start
(defun @ghost(/ k j ss ss1 en ed etn x10 x11 lis n dissum dis)
   (setvar "cmdecho" 0)
   (prompt "\n>>  ü ϱ<text/mtext/line/pline/>..")
   (setq k 0 j 0)
   (setq ss (ssget "x" (list (cons 0 "text,mtext") (cons 1 ""))))
   (setq ss1 (ssget "x" (list (cons 0 "line,lwpolyline"))))
   (if ss1 (progn
      (repeat (sslength ss1)
         (setq en (ssname ss1 k)
                  ed (entget en)
                  etn (cdr (assoc 0 ed)))
         (cond ((= etn "LINE")
            (setq x10 (cdr (assoc 10 ed))
                     x11 (cdr (assoc 11 ed)))
            (if (= (distance x10 x11) 0) (progn (command "erase" en "") (setq j (1+ j)))))
            ((= etn "LWPOLYLINE")
               (setq lis (GetPolyVtx ed))
               (setq n 0 dissum 0)
               (repeat (1- (length lis))
                  (setq dis (distance (nth n lis) (nth (1+ n) lis)))
                  (setq dissum (+ dissum dis))
                  (setq n (1+ n))
               )
               (if (= dissum 0) (progn (command "erase" en "") (setq j (1+ j))))
            )
         );cond
      (setq k (+ k 1))
      );repeat
  ));if progn
   (if (> j 0) (progn (princ "\n-> 0  ü ") (princ j) (princ "") (princ " Ͽϴ.")))
;  text -> erase
   (if ss (progn (command "erase" ss "") (princ "\n->  text ")
         (princ (sslength ss)) (princ "") (princ " Ͽϴ.") ))
(princ))
;
(defun GetPolyVtx(EntList)
   (setq VtxList '())
   (foreach x EntList
      (if (= (car x) 10) (setq VtxList (append VtxList (list (cdr x)))) )
   )
VtxList)
;-->ghost end
;; pointdelete
(defun @pointdelete(/ ss)
   (setq ss (ssget "x" (list (cons 0 "point"))))
   (if ss (progn (command "erase" ss "") (princ "\n->Point<node> ")
         (princ (sslength ss)) (princ "") (princ " Ͽϴ.") ))
(prin1))


